/*----- PROTECTED REGION ID(Agilent33500BClass.h) ENABLED START -----*/
//=============================================================================
//
// file :        Agilent33500BClass.h
//
// description : Include for the Agilent33500B root class.
//               This class is the singleton class for
//                the Agilent33500B device class.
//               It contains all properties and methods which the 
//               Agilent33500B requires only once e.g. the commands.
//
// project :     Agilent33500B
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef Agilent33500BClass_H
#define Agilent33500BClass_H

// #include <tango.h>
#include "Agilent33500B.h"


/*----- PROTECTED REGION END -----*/	//	Agilent33500BClass.h


namespace Agilent33500B_ns
{
/*----- PROTECTED REGION ID(Agilent33500BClass::classes for dynamic creation) ENABLED START -----*/


/*----- PROTECTED REGION END -----*/	//	Agilent33500BClass::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute Impedance class definition
class ImpedanceAttrib: public Tango::Attr
{
public:
	ImpedanceAttrib():Attr("Impedance",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {}
	~ImpedanceAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent33500B *>(dev))->read_Impedance(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Agilent33500B *>(dev))->write_Impedance(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent33500B *>(dev))->is_Impedance_allowed(ty);}
};

//	Attribute Amplitude class definition
class AmplitudeAttrib: public Tango::Attr
{
public:
	AmplitudeAttrib():Attr("Amplitude",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {}
	~AmplitudeAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent33500B *>(dev))->read_Amplitude(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Agilent33500B *>(dev))->write_Amplitude(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent33500B *>(dev))->is_Amplitude_allowed(ty);}
};

//	Attribute Offset class definition
class OffsetAttrib: public Tango::Attr
{
public:
	OffsetAttrib():Attr("Offset",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {}
	~OffsetAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent33500B *>(dev))->read_Offset(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Agilent33500B *>(dev))->write_Offset(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent33500B *>(dev))->is_Offset_allowed(ty);}
};

//	Attribute SampleRate class definition
class SampleRateAttrib: public Tango::Attr
{
public:
	SampleRateAttrib():Attr("SampleRate",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {}
	~SampleRateAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent33500B *>(dev))->read_SampleRate(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Agilent33500B *>(dev))->write_SampleRate(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent33500B *>(dev))->is_SampleRate_allowed(ty);}
};

//	Attribute TriggerMode class definition
class TriggerModeAttrib: public Tango::Attr
{
public:
	TriggerModeAttrib():Attr("TriggerMode",
			Tango::DEV_SHORT, Tango::READ_WRITE) {}
	~TriggerModeAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent33500B *>(dev))->read_TriggerMode(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Agilent33500B *>(dev))->write_TriggerMode(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent33500B *>(dev))->is_TriggerMode_allowed(ty);}
};

//	Attribute Triggering class definition
class TriggeringAttrib: public Tango::Attr
{
public:
	TriggeringAttrib():Attr("Triggering",
			Tango::DEV_SHORT, Tango::READ_WRITE) {}
	~TriggeringAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent33500B *>(dev))->read_Triggering(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Agilent33500B *>(dev))->write_Triggering(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent33500B *>(dev))->is_Triggering_allowed(ty);}
};

//	Attribute Delay class definition
class DelayAttrib: public Tango::Attr
{
public:
	DelayAttrib():Attr("Delay",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {}
	~DelayAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent33500B *>(dev))->read_Delay(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Agilent33500B *>(dev))->write_Delay(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent33500B *>(dev))->is_Delay_allowed(ty);}
};

//	Attribute TrackMode class definition
class TrackModeAttrib: public Tango::Attr
{
public:
	TrackModeAttrib():Attr("TrackMode",
			Tango::DEV_SHORT, Tango::READ_WRITE) {}
	~TrackModeAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent33500B *>(dev))->read_TrackMode(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Agilent33500B *>(dev))->write_TrackMode(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent33500B *>(dev))->is_TrackMode_allowed(ty);}
};

//	Attribute BurstMode class definition
class BurstModeAttrib: public Tango::Attr
{
public:
	BurstModeAttrib():Attr("BurstMode",
			Tango::DEV_SHORT, Tango::READ_WRITE) {}
	~BurstModeAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent33500B *>(dev))->read_BurstMode(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Agilent33500B *>(dev))->write_BurstMode(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent33500B *>(dev))->is_BurstMode_allowed(ty);}
};

//	Attribute BurstCycle class definition
class BurstCycleAttrib: public Tango::Attr
{
public:
	BurstCycleAttrib():Attr("BurstCycle",
			Tango::DEV_SHORT, Tango::READ_WRITE) {}
	~BurstCycleAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent33500B *>(dev))->read_BurstCycle(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Agilent33500B *>(dev))->write_BurstCycle(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent33500B *>(dev))->is_BurstCycle_allowed(ty);}
};

//	Attribute BurstState class definition
class BurstStateAttrib: public Tango::Attr
{
public:
	BurstStateAttrib():Attr("BurstState",
			Tango::DEV_SHORT, Tango::READ_WRITE) {}
	~BurstStateAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent33500B *>(dev))->read_BurstState(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Agilent33500B *>(dev))->write_BurstState(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent33500B *>(dev))->is_BurstState_allowed(ty);}
};

//	Attribute HighVoltage class definition
class HighVoltageAttrib: public Tango::Attr
{
public:
	HighVoltageAttrib():Attr("HighVoltage",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {}
	~HighVoltageAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent33500B *>(dev))->read_HighVoltage(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Agilent33500B *>(dev))->write_HighVoltage(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent33500B *>(dev))->is_HighVoltage_allowed(ty);}
};

//	Attribute LowVoltage class definition
class LowVoltageAttrib: public Tango::Attr
{
public:
	LowVoltageAttrib():Attr("LowVoltage",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {}
	~LowVoltageAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent33500B *>(dev))->read_LowVoltage(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Agilent33500B *>(dev))->write_LowVoltage(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent33500B *>(dev))->is_LowVoltage_allowed(ty);}
};

//	Attribute Configuration_File class definition
class Configuration_FileAttrib: public Tango::Attr
{
public:
	Configuration_FileAttrib():Attr("Configuration_File",
			Tango::DEV_STRING, Tango::READ) {}
	~Configuration_FileAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent33500B *>(dev))->read_Configuration_File(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent33500B *>(dev))->is_Configuration_File_allowed(ty);}
};

//	Attribute Function class definition
class FunctionAttrib: public Tango::Attr
{
public:
	FunctionAttrib():Attr("Function",
			Tango::DEV_SHORT, Tango::READ_WRITE) {}
	~FunctionAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent33500B *>(dev))->read_Function(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Agilent33500B *>(dev))->write_Function(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent33500B *>(dev))->is_Function_allowed(ty);}
};

//	Attribute Frequency class definition
class FrequencyAttrib: public Tango::Attr
{
public:
	FrequencyAttrib():Attr("Frequency",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {}
	~FrequencyAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent33500B *>(dev))->read_Frequency(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Agilent33500B *>(dev))->write_Frequency(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent33500B *>(dev))->is_Frequency_allowed(ty);}
};

//	Attribute NoiseBandwidth class definition
class NoiseBandwidthAttrib: public Tango::Attr
{
public:
	NoiseBandwidthAttrib():Attr("NoiseBandwidth",
			Tango::DEV_DOUBLE, Tango::READ_WRITE) {}
	~NoiseBandwidthAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent33500B *>(dev))->read_NoiseBandwidth(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Agilent33500B *>(dev))->write_NoiseBandwidth(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent33500B *>(dev))->is_NoiseBandwidth_allowed(ty);}
};

//	Attribute OutputMode class definition
class OutputModeAttrib: public Tango::Attr
{
public:
	OutputModeAttrib():Attr("OutputMode",
			Tango::DEV_SHORT, Tango::READ_WRITE) {}
	~OutputModeAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent33500B *>(dev))->read_OutputMode(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Agilent33500B *>(dev))->write_OutputMode(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent33500B *>(dev))->is_OutputMode_allowed(ty);}
};

//	Attribute WaveformFilter class definition
class WaveformFilterAttrib: public Tango::Attr
{
public:
	WaveformFilterAttrib():Attr("WaveformFilter",
			Tango::DEV_SHORT, Tango::READ_WRITE) {}
	~WaveformFilterAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent33500B *>(dev))->read_WaveformFilter(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Agilent33500B *>(dev))->write_WaveformFilter(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent33500B *>(dev))->is_WaveformFilter_allowed(ty);}
};

//	Attribute Waveform class definition
class WaveformAttrib: public Tango::SpectrumAttr
{
public:
	// Constants for Waveform attribute
	constexpr static long X_DATA_SIZE = 16000000;
	WaveformAttrib():SpectrumAttr("Waveform",
			Tango::DEV_DOUBLE, Tango::READ_WRITE, WaveformAttrib::X_DATA_SIZE) {}
	~WaveformAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<Agilent33500B *>(dev))->read_Waveform(att);}
	virtual void write(Tango::DeviceImpl *dev,Tango::WAttribute &att)
		{(static_cast<Agilent33500B *>(dev))->write_Waveform(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<Agilent33500B *>(dev))->is_Waveform_allowed(ty);}
};


//=========================================
//	Define classes for commands
//=========================================
//	Command Reset class definition
class ResetClass : public Tango::Command
{
public:
	ResetClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	ResetClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~ResetClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Agilent33500B *>(dev))->is_Reset_allowed(any);}
};

//	Command On class definition
class OnClass : public Tango::Command
{
public:
	OnClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	OnClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~OnClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Agilent33500B *>(dev))->is_On_allowed(any);}
};

//	Command Off class definition
class OffClass : public Tango::Command
{
public:
	OffClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	OffClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~OffClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Agilent33500B *>(dev))->is_Off_allowed(any);}
};

//	Command LoadConfigurationFile class definition
class LoadConfigurationFileClass : public Tango::Command
{
public:
	LoadConfigurationFileClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	LoadConfigurationFileClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~LoadConfigurationFileClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Agilent33500B *>(dev))->is_LoadConfigurationFile_allowed(any);}
};

//	Command SaveConfigurationFile class definition
class SaveConfigurationFileClass : public Tango::Command
{
public:
	SaveConfigurationFileClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	SaveConfigurationFileClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~SaveConfigurationFileClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Agilent33500B *>(dev))->is_SaveConfigurationFile_allowed(any);}
};

//	Command GetConfigurationFilePath class definition
class GetConfigurationFilePathClass : public Tango::Command
{
public:
	GetConfigurationFilePathClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	GetConfigurationFilePathClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~GetConfigurationFilePathClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Agilent33500B *>(dev))->is_GetConfigurationFilePath_allowed(any);}
};

//	Command SaveToFlash class definition
class SaveToFlashClass : public Tango::Command
{
public:
	SaveToFlashClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	SaveToFlashClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~SaveToFlashClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Agilent33500B *>(dev))->is_SaveToFlash_allowed(any);}
};

//	Command ReLoadConfigurationFile class definition
class ReLoadConfigurationFileClass : public Tango::Command
{
public:
	ReLoadConfigurationFileClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	ReLoadConfigurationFileClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~ReLoadConfigurationFileClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<Agilent33500B *>(dev))->is_ReLoadConfigurationFile_allowed(any);}
};


/**
 *	The Agilent33500BClass singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  Agilent33500BClass : public Tango::DeviceClass
#else
class Agilent33500BClass : public Tango::DeviceClass
#endif
{
	/*----- PROTECTED REGION ID(Agilent33500BClass::Additional DServer data members) ENABLED START -----*/
	
	
	/*----- PROTECTED REGION END -----*/	//	Agilent33500BClass::Additional DServer data members

	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
		//	Method prototypes
		static Agilent33500BClass *init(const char *);
		static Agilent33500BClass *instance();
		~Agilent33500BClass();
		Tango::DbDatum	get_class_property(std::string &);
		Tango::DbDatum	get_default_device_property(std::string &);
		Tango::DbDatum	get_default_class_property(std::string &);

	protected:
		Agilent33500BClass(std::string &);
		static Agilent33500BClass *_instance;
		void command_factory();
		void attribute_factory(std::vector<Tango::Attr *> &);
		void pipe_factory();
		void write_class_property();
		void set_default_property();
		void get_class_property();
		std::string get_cvstag();
		std::string get_cvsroot();

	private:
		void device_factory(TANGO_UNUSED(const Tango::DevVarStringArray *));
		void create_static_attribute_list(std::vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,std::vector<Tango::Attr *> &);
		std::vector<std::string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(std::vector<Tango::Attr *> &att_list, std::string attname);
};

}	//	End of namespace

#endif   //	Agilent33500B_H
